"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
require("@samnbuk/react_db_client.testing.enzyme-setup");
const react_1 = __importDefault(require("react"));
const enzyme_1 = require("enzyme");
const test_utils_1 = require("react-dom/test-utils");
const field_file_1 = require("./field-file");
const components_item_list_1 = require("@react_db_client/components.item-list");
const compositions = __importStar(require("./field-file.composition"));
const demo_data_1 = require("./demo-data");
const updateFormData = jest.fn();
const asyncGetDocuments = jest.fn();
const defaultProps = {
    uid: 'uid',
    multiple: false,
    updateFormData,
    collectionId: 'collectionId',
    documentId: 'documentId',
    fileType: 'image',
    value: demo_data_1.DEMO_FILES_DATA,
    fileServerUrl: 'fileserver',
    asyncGetDocuments,
};
describe('field-file', () => {
    beforeEach(() => {
        updateFormData.mockClear();
        asyncGetDocuments.mockClear();
    });
    test('Renders', () => {
        (0, enzyme_1.shallow)(react_1.default.createElement(field_file_1.FieldFile, Object.assign({}, defaultProps)));
    });
    describe('Compositions', () => {
        Object.entries(compositions).forEach(([name, Composition]) => {
            test(name, () => {
                (0, enzyme_1.mount)(react_1.default.createElement(Composition, null));
            });
        });
    });
    describe('shallow renders', () => {
        test('Matches Snapshot', () => {
            const component = (0, enzyme_1.shallow)(react_1.default.createElement(field_file_1.FieldFile, Object.assign({}, defaultProps)));
            const tree = component.debug();
            expect(tree).toMatchSnapshot();
        });
    });
    describe('Unit tests', () => {
        let component;
        describe('Single', () => {
            beforeEach(() => {
                component = (0, enzyme_1.mount)(react_1.default.createElement(field_file_1.FieldFile, Object.assign({}, defaultProps)));
            });
            test.skip('should pass empty list to item list if there are no files', () => __awaiter(void 0, void 0, void 0, function* () {
                yield (0, test_utils_1.act)(() => __awaiter(void 0, void 0, void 0, function* () {
                    component.setProps({ value: null });
                    component.update();
                    yield new Promise((resolve) => setTimeout(resolve));
                }));
                const itemList = component.find(components_item_list_1.ItemList);
                // TODO: For some reason this is failing but correct in debug
                expect(itemList.props().items).toEqual([]);
            }));
            test('should call updatedate with null when we delete the file', () => {
                const fileDeleteFn = component
                    .find(components_item_list_1.ItemList)
                    .props()
                    .overlayButtons.find((f) => f.uid === 'remove').func;
                (0, test_utils_1.act)(() => {
                    fileDeleteFn(demo_data_1.DEMO_FILES_DATA[0].uid);
                });
                expect(updateFormData).toHaveBeenCalledWith(defaultProps.uid, null);
            });
        });
        describe('Multiple', () => {
            beforeEach(() => {
                component = (0, enzyme_1.mount)(react_1.default.createElement(field_file_1.FieldFile, Object.assign({}, defaultProps, { multiple: true })));
            });
            test('should pass empty list to item list if there are no files', () => {
                component.setProps({ value: null });
                component.update();
                const itemList = component.find(components_item_list_1.ItemList);
                expect(itemList.props().items).toEqual([]);
            });
            test('should call updatedata with file removed when we delete the file', () => {
                const fileDeleteFn = component
                    .find(components_item_list_1.ItemList)
                    .props()
                    .overlayButtons.find((f) => f.uid === 'remove').func;
                (0, test_utils_1.act)(() => {
                    fileDeleteFn(demo_data_1.DEMO_FILES_DATA[0].uid);
                });
                expect(updateFormData).toHaveBeenCalledWith(defaultProps.uid, demo_data_1.DEMO_FILES_DATA.slice(1));
            });
        });
    });
});
//# sourceMappingURL=field-file.test.js.map